export declare type RoomHandler = (event: string, payload: any) => void;
export interface RoomEventHandlersType {
    [key: string]: RoomHandler[];
}
export declare class Room {
    private ws;
    private isJoined;
    private topic;
    private room;
    private eventHandlers;
    static errorAlreadyJoined: Error;
    static errorNotJoined: Error;
    constructor(ws: WebSocket, fullName: string);
    join(opts?: any): void;
    send(event: string, payload: any): void;
    leave(payload: any): void;
    onEvent(event: string, handler: RoomHandler): void;
    messageReceived(event: string, payload: any): void;
}
