import { Room } from './room';
export interface SocketOpts {
    timeout: number;
    backoffScale: number;
}
export declare type WSEventHandler = (event: Event) => void;
export declare class Socket {
    ws: WebSocket | null;
    url: string;
    opts: SocketOpts;
    currentTimeout: number;
    openHandlers: WSEventHandler[];
    closeHandlers: WSEventHandler[];
    errorHandlers: WSEventHandler[];
    private rooms;
    static notConnectedError: Error;
    constructor(url: string, opts?: Partial<SocketOpts>);
    connect(): void;
    join(channel: string, opts?: any): Room;
    onOpen(fn: WSEventHandler): void;
    onClose(fn: WSEventHandler): void;
    onError(fn: WSEventHandler): void;
}
